package sun.security.tools.policytool;

import java.io.PrintWriter;
import java.io.StringWriter;
import javax.swing.DefaultListModel;
import java.io.FileNotFoundException;
import java.io.File;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import java.awt.FileDialog;
import java.text.MessageFormat;
import javax.swing.JComboBox;
import java.io.IOException;
import java.security.cert.CertificateException;
import java.lang.reflect.InvocationTargetException;
import java.net.MalformedURLException;
import java.security.InvalidParameterException;
import java.util.Vector;
import java.util.LinkedList;
import javax.swing.JButton;
import java.awt.Dimension;
import javax.swing.JTextField;
import javax.swing.JLabel;
import sun.security.provider.PolicyParser;
import javax.swing.JList;
import java.awt.GridBagLayout;
import javax.swing.JScrollPane;
import java.awt.Component;
import javax.swing.border.EmptyBorder;
import javax.swing.JPanel;
import java.util.ArrayList;
import javax.swing.KeyStroke;
import javax.swing.JDialog;

class ToolDialog extends JDialog
{
    private static final long serialVersionUID = -372244357011301190L;
    static final KeyStroke escKey;
    public static final int NOACTION = 0;
    public static final int QUIT = 1;
    public static final int NEW = 2;
    public static final int OPEN = 3;
    public static final String ALL_PERM_CLASS = "java.security.AllPermission";
    public static final String FILE_PERM_CLASS = "java.io.FilePermission";
    public static final String X500_PRIN_CLASS = "javax.security.auth.x500.X500Principal";
    public static final String PERM;
    public static final String PRIN_TYPE;
    public static final String PRIN_NAME;
    public static final String PERM_NAME;
    public static final String PERM_ACTIONS;
    public static final int PE_CODEBASE_LABEL = 0;
    public static final int PE_CODEBASE_TEXTFIELD = 1;
    public static final int PE_SIGNEDBY_LABEL = 2;
    public static final int PE_SIGNEDBY_TEXTFIELD = 3;
    public static final int PE_PANEL0 = 4;
    public static final int PE_ADD_PRIN_BUTTON = 0;
    public static final int PE_EDIT_PRIN_BUTTON = 1;
    public static final int PE_REMOVE_PRIN_BUTTON = 2;
    public static final int PE_PRIN_LABEL = 5;
    public static final int PE_PRIN_LIST = 6;
    public static final int PE_PANEL1 = 7;
    public static final int PE_ADD_PERM_BUTTON = 0;
    public static final int PE_EDIT_PERM_BUTTON = 1;
    public static final int PE_REMOVE_PERM_BUTTON = 2;
    public static final int PE_PERM_LIST = 8;
    public static final int PE_PANEL2 = 9;
    public static final int PE_CANCEL_BUTTON = 1;
    public static final int PE_DONE_BUTTON = 0;
    public static final int PRD_DESC_LABEL = 0;
    public static final int PRD_PRIN_CHOICE = 1;
    public static final int PRD_PRIN_TEXTFIELD = 2;
    public static final int PRD_NAME_LABEL = 3;
    public static final int PRD_NAME_TEXTFIELD = 4;
    public static final int PRD_CANCEL_BUTTON = 6;
    public static final int PRD_OK_BUTTON = 5;
    public static final int PD_DESC_LABEL = 0;
    public static final int PD_PERM_CHOICE = 1;
    public static final int PD_PERM_TEXTFIELD = 2;
    public static final int PD_NAME_CHOICE = 3;
    public static final int PD_NAME_TEXTFIELD = 4;
    public static final int PD_ACTIONS_CHOICE = 5;
    public static final int PD_ACTIONS_TEXTFIELD = 6;
    public static final int PD_SIGNEDBY_LABEL = 7;
    public static final int PD_SIGNEDBY_TEXTFIELD = 8;
    public static final int PD_CANCEL_BUTTON = 10;
    public static final int PD_OK_BUTTON = 9;
    public static final int EDIT_KEYSTORE = 0;
    public static final int KSD_NAME_LABEL = 0;
    public static final int KSD_NAME_TEXTFIELD = 1;
    public static final int KSD_TYPE_LABEL = 2;
    public static final int KSD_TYPE_TEXTFIELD = 3;
    public static final int KSD_PROVIDER_LABEL = 4;
    public static final int KSD_PROVIDER_TEXTFIELD = 5;
    public static final int KSD_PWD_URL_LABEL = 6;
    public static final int KSD_PWD_URL_TEXTFIELD = 7;
    public static final int KSD_CANCEL_BUTTON = 9;
    public static final int KSD_OK_BUTTON = 8;
    public static final int USC_LABEL = 0;
    public static final int USC_PANEL = 1;
    public static final int USC_YES_BUTTON = 0;
    public static final int USC_NO_BUTTON = 1;
    public static final int USC_CANCEL_BUTTON = 2;
    public static final int CRPE_LABEL1 = 0;
    public static final int CRPE_LABEL2 = 1;
    public static final int CRPE_PANEL = 2;
    public static final int CRPE_PANEL_OK = 0;
    public static final int CRPE_PANEL_CANCEL = 1;
    private static final int PERMISSION = 0;
    private static final int PERMISSION_NAME = 1;
    private static final int PERMISSION_ACTIONS = 2;
    private static final int PERMISSION_SIGNEDBY = 3;
    private static final int PRINCIPAL_TYPE = 4;
    private static final int PRINCIPAL_NAME = 5;
    static final int TEXTFIELD_HEIGHT;
    public static ArrayList<Perm> PERM_ARRAY;
    public static ArrayList<Prin> PRIN_ARRAY;
    PolicyTool tool;
    ToolWindow tw;
    
    ToolDialog(String title, PolicyTool tool, ToolWindow toolWindow, boolean modal) {
        super(toolWindow, modal);
        this.setTitle(title);
        this.tool = tool;
        this.tw = toolWindow;
        this.addWindowListener(new ChildWindowListener(this));
        ((JPanel)this.getContentPane()).setBorder(new EmptyBorder(6, 6, 6, 6));
    }
    
    @Override
    public Component getComponent(int n) {
        Component component = this.getContentPane().getComponent(n);
        if ((component instanceof JScrollPane)) {
            component = ((JScrollPane)component).getViewport().getView();
            return component;
        }
        return component;
    }
    
    static Perm getPerm(String s, boolean b) {
        for (int i = 0; i < ToolDialog.PERM_ARRAY.size(); ++i) {
            Perm perm = (Perm)ToolDialog.PERM_ARRAY.get(i);
            if (b) {
                if (perm.FULL_CLASS.equals(s)) {
                    return perm;
                }
            }
            else if (perm.CLASS.equals(s)) {
                return perm;
            }
        }
        return null;
    }
    
    static Prin getPrin(String s, boolean b) {
        for (int i = 0; i < ToolDialog.PRIN_ARRAY.size(); ++i) {
            Prin prin = (Prin)ToolDialog.PRIN_ARRAY.get(i);
            if (b) {
                if (prin.FULL_CLASS.equals(s)) {
                    return prin;
                }
            }
            else if (prin.CLASS.equals(s)) {
                return prin;
            }
        }
        return null;
    }
    
    void displayPolicyEntryDialog(boolean b) {
        int selectedIndex = 0;
        PolicyEntry[] entry = null;
        TaggedList view = new TaggedList(3, false);
        view.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("Principal.List"));
        view.addMouseListener(new EditPrinButtonListener(this.tool, this.tw, this, b));
        TaggedList view2 = new TaggedList(10, false);
        view2.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("Permission.List"));
        view2.addMouseListener(new EditPermButtonListener(this.tool, this.tw, this, b));
        this.tw.getLocationOnScreen();
        this.setLayout(new GridBagLayout());
        this.setResizable(true);
        if (b) {
            entry = this.tool.getEntry();
            selectedIndex = ((JList)this.tw.getComponent(3)).getSelectedIndex();
            LinkedList<Object> principals = entry[selectedIndex].getGrantEntry().principals;
            for (int i = 0; i < principals.size(); ++i) {
                PolicyParser.PrincipalEntry principalEntry = (PolicyParser.PrincipalEntry)principals.get(i);
                view.addTaggedItem(PrincipalEntryToUserFriendlyString(principalEntry), principalEntry);
            }
            Vector<Object> permissionEntries = entry[selectedIndex].getGrantEntry().permissionEntries;
            for (int j = 0; j < permissionEntries.size(); ++j) {
                PolicyParser.PermissionEntry permissionEntry = (PolicyParser.PermissionEntry)permissionEntries.elementAt(j);
                view2.addTaggedItem(PermissionEntryToUserFriendlyString(permissionEntry), permissionEntry);
            }
        }
        JLabel o = new JLabel();
        this.tw.addNewComponent(this, o, 0, 0, 0, 1, 1, 0.0, 0.0, 1, ToolWindow.R_PADDING);
        Object o2 = b ? new JTextField(entry[selectedIndex].getGrantEntry().codeBase) : new JTextField();
        ToolWindow.configureLabelFor(o, o2, "CodeBase.");
        o2.setPreferredSize(new Dimension(o2.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
        o2.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("Code.Base"));
        this.tw.addNewComponent(this, o2, 1, 1, 0, 1, 1, 1.0, 0.0, 1);
        JLabel o3 = new JLabel();
        this.tw.addNewComponent(this, o3, 2, 0, 1, 1, 1, 0.0, 0.0, 1, ToolWindow.R_PADDING);
        Object o4 = b ? new JTextField(entry[selectedIndex].getGrantEntry().signedBy) : new JTextField();
        ToolWindow.configureLabelFor(o3, o4, "SignedBy.");
        o4.setPreferredSize(new Dimension(o4.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
        o4.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("Signed.By."));
        this.tw.addNewComponent(this, o4, 3, 1, 1, 1, 1, 1.0, 0.0, 1);
        JPanel o5 = new JPanel();
        o5.setLayout(new GridBagLayout());
        JButton o6 = new JButton();
        ToolWindow.configureButton(o6, "Add.Principal");
        o6.addActionListener(new AddPrinButtonListener(this.tool, this.tw, this, b));
        this.tw.addNewComponent(o5, o6, 0, 0, 0, 1, 1, 100.0, 0.0, 2);
        JButton o7 = new JButton();
        ToolWindow.configureButton(o7, "Edit.Principal");
        o7.addActionListener(new EditPrinButtonListener(this.tool, this.tw, this, b));
        this.tw.addNewComponent(o5, o7, 1, 1, 0, 1, 1, 100.0, 0.0, 2);
        JButton o8 = new JButton();
        ToolWindow.configureButton(o8, "Remove.Principal");
        o8.addActionListener(new RemovePrinButtonListener(this.tool, this.tw, this, b));
        this.tw.addNewComponent(o5, o8, 2, 2, 0, 1, 1, 100.0, 0.0, 2);
        this.tw.addNewComponent(this, o5, 4, 1, 2, 1, 1, 0.0, 0.0, 2, ToolWindow.LITE_BOTTOM_PADDING);
        JLabel o9 = new JLabel();
        this.tw.addNewComponent(this, o9, 5, 0, 3, 1, 1, 0.0, 0.0, 1, ToolWindow.R_BOTTOM_PADDING);
        JScrollPane o10 = new JScrollPane(view);
        ToolWindow.configureLabelFor(o9, o10, "Principals.");
        this.tw.addNewComponent(this, o10, 6, 1, 3, 3, 1, 0.0, (double)view.getVisibleRowCount(), 1, ToolWindow.BOTTOM_PADDING);
        JPanel o11 = new JPanel();
        o11.setLayout(new GridBagLayout());
        JButton o12 = new JButton();
        ToolWindow.configureButton(o12, ".Add.Permission");
        o12.addActionListener(new AddPermButtonListener(this.tool, this.tw, this, b));
        this.tw.addNewComponent(o11, o12, 0, 0, 0, 1, 1, 100.0, 0.0, 2);
        JButton o13 = new JButton();
        ToolWindow.configureButton(o13, ".Edit.Permission");
        o13.addActionListener(new EditPermButtonListener(this.tool, this.tw, this, b));
        this.tw.addNewComponent(o11, o13, 1, 1, 0, 1, 1, 100.0, 0.0, 2);
        JButton o14 = new JButton();
        ToolWindow.configureButton(o14, "Remove.Permission");
        o14.addActionListener(new RemovePermButtonListener(this.tool, this.tw, this, b));
        this.tw.addNewComponent(o11, o14, 2, 2, 0, 1, 1, 100.0, 0.0, 2);
        this.tw.addNewComponent(this, o11, 7, 0, 4, 2, 1, 0.0, 0.0, 2, ToolWindow.LITE_BOTTOM_PADDING);
        this.tw.addNewComponent(this, new JScrollPane(view2), 8, 0, 5, 3, 1, 0.0, (double)view2.getVisibleRowCount(), 1, ToolWindow.BOTTOM_PADDING);
        JPanel o15 = new JPanel();
        o15.setLayout(new GridBagLayout());
        JButton defaultButton = new JButton(PolicyTool.getMessage("Done"));
        defaultButton.addActionListener(new AddEntryDoneButtonListener(this.tool, this.tw, this, b));
        this.tw.addNewComponent(o15, defaultButton, 0, 0, 0, 1, 1, 0.0, 0.0, 3, ToolWindow.LR_PADDING);
        JButton o16 = new JButton(PolicyTool.getMessage("Cancel"));
        CancelButtonListener o17 = new CancelButtonListener(this);
        o16.addActionListener(o17);
        this.tw.addNewComponent(o15, o16, 1, 1, 0, 1, 1, 0.0, 0.0, 3, ToolWindow.LR_PADDING);
        this.tw.addNewComponent(this, o15, 9, 0, 6, 2, 1, 0.0, 0.0, 3);
        this.getRootPane().setDefaultButton(defaultButton);
        this.getRootPane().registerKeyboardAction(o17, ToolDialog.escKey, 2);
        this.pack();
        this.setLocationRelativeTo(this.tw);
        this.setVisible(true);
    }
    
    PolicyEntry getPolicyEntryFromDialog() throws InvalidParameterException, MalformedURLException, NoSuchMethodException, ClassNotFoundException, InstantiationException, IllegalAccessException, InvocationTargetException, CertificateException, IOException, Exception {
        JTextField textField = (JTextField)this.getComponent(1);
        String codeBase = null;
        if (!textField.getText().trim().equals("")) {
            codeBase = new String(textField.getText().trim());
        }
        JTextField textField2 = (JTextField)this.getComponent(3);
        Object signedBy = null;
        if (!textField2.getText().trim().equals("")) {
            signedBy = new String(textField2.getText().trim());
        }
        PolicyParser.GrantEntry o = new PolicyParser.GrantEntry(signedBy, codeBase);
        LinkedList principals = new LinkedList();
        TaggedList list = (TaggedList)this.getComponent(6);
        for (int i = 0; i < list.getModel().getSize(); ++i) {
            principals.add((Object)list.getObject(i));
        }
        o.principals = principals;
        Vector permissionEntries = new Vector();
        TaggedList list2 = (TaggedList)this.getComponent(8);
        for (int j = 0; j < list2.getModel().getSize(); ++j) {
            permissionEntries.addElement((Object)list2.getObject(j));
        }
        o.permissionEntries = permissionEntries;
        return new PolicyEntry(this.tool, o);
    }
    
    void keyStoreDialog(int n) {
        this.tw.getLocationOnScreen();
        this.setLayout(new GridBagLayout());
        if (n == 0) {
            JLabel label = new JLabel();
            this.tw.addNewComponent(this, label, 0, 0, 0, 1, 1, 0.0, 0.0, 1, ToolWindow.R_BOTTOM_PADDING);
            JTextField textField = new JTextField(this.tool.getKeyStoreName(), 30);
            ToolWindow.configureLabelFor(label, textField, "KeyStore.URL.");
            textField.setPreferredSize(new Dimension(textField.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
            textField.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("KeyStore.U.R.L."));
            this.tw.addNewComponent(this, textField, 1, 1, 0, 1, 1, 1.0, 0.0, 1, ToolWindow.BOTTOM_PADDING);
            JLabel label2 = new JLabel();
            this.tw.addNewComponent(this, label2, 2, 0, 1, 1, 1, 0.0, 0.0, 1, ToolWindow.R_BOTTOM_PADDING);
            JTextField textField2 = new JTextField(this.tool.getKeyStoreType(), 30);
            ToolWindow.configureLabelFor(label2, textField2, "KeyStore.Type.");
            textField2.setPreferredSize(new Dimension(textField2.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
            textField2.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("KeyStore.Type."));
            this.tw.addNewComponent(this, textField2, 3, 1, 1, 1, 1, 1.0, 0.0, 1, ToolWindow.BOTTOM_PADDING);
            JLabel label3 = new JLabel();
            this.tw.addNewComponent(this, label3, 4, 0, 2, 1, 1, 0.0, 0.0, 1, ToolWindow.R_BOTTOM_PADDING);
            JTextField textField3 = new JTextField(this.tool.getKeyStoreProvider(), 30);
            ToolWindow.configureLabelFor(label3, textField3, "KeyStore.Provider.");
            textField3.setPreferredSize(new Dimension(textField3.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
            textField3.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("KeyStore.Provider."));
            this.tw.addNewComponent(this, textField3, 5, 1, 2, 1, 1, 1.0, 0.0, 1, ToolWindow.BOTTOM_PADDING);
            JLabel label4 = new JLabel();
            this.tw.addNewComponent(this, label4, 6, 0, 3, 1, 1, 0.0, 0.0, 1, ToolWindow.R_BOTTOM_PADDING);
            JTextField textField4 = new JTextField(this.tool.getKeyStorePwdURL(), 30);
            ToolWindow.configureLabelFor(label4, textField4, "KeyStore.Password.URL.");
            textField4.setPreferredSize(new Dimension(textField4.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
            textField4.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("KeyStore.Password.U.R.L."));
            this.tw.addNewComponent(this, textField4, 7, 1, 3, 1, 1, 1.0, 0.0, 1, ToolWindow.BOTTOM_PADDING);
            JButton defaultButton = new JButton(PolicyTool.getMessage("OK"));
            defaultButton.addActionListener(new ChangeKeyStoreOKButtonListener(this.tool, this.tw, this));
            this.tw.addNewComponent(this, defaultButton, 8, 0, 4, 1, 1, 0.0, 0.0, 3);
            JButton button = new JButton(PolicyTool.getMessage("Cancel"));
            CancelButtonListener cancelButtonListener = new CancelButtonListener(this);
            button.addActionListener(cancelButtonListener);
            this.tw.addNewComponent(this, button, 9, 1, 4, 1, 1, 0.0, 0.0, 3);
            this.getRootPane().setDefaultButton(defaultButton);
            this.getRootPane().registerKeyboardAction(cancelButtonListener, ToolDialog.escKey, 2);
        }
        this.pack();
        this.setLocationRelativeTo(this.tw);
        this.setVisible(true);
    }
    
    void displayPrincipalDialog(boolean b, boolean b2) {
        PolicyParser.PrincipalEntry principalEntry = null;
        TaggedList list = (TaggedList)this.getComponent(6);
        int selectedIndex = list.getSelectedIndex();
        if (b2) {
            principalEntry = (PolicyParser.PrincipalEntry)list.getObject(selectedIndex);
        }
        ToolDialog o = new ToolDialog(PolicyTool.getMessage("Principals"), this.tool, this.tw, true);
        o.addWindowListener(new ChildWindowListener(o));
        this.getLocationOnScreen();
        o.setLayout(new GridBagLayout());
        o.setResizable(true);
        this.tw.addNewComponent(o, b2 ? new JLabel(PolicyTool.getMessage(".Edit.Principal.")) : new JLabel(PolicyTool.getMessage(".Add.New.Principal.")), 0, 0, 0, 1, 1, 0.0, 0.0, 1, ToolWindow.TOP_BOTTOM_PADDING);
        JComboBox o2 = new JComboBox();
        o2.addItem(ToolDialog.PRIN_TYPE);
        o2.getAccessibleContext().setAccessibleName(ToolDialog.PRIN_TYPE);
        for (int i = 0; i < ToolDialog.PRIN_ARRAY.size(); ++i) {
            o2.addItem(((Prin)ToolDialog.PRIN_ARRAY.get(i)).CLASS);
        }
        if (b2) {
            if ("WILDCARD_PRINCIPAL_CLASS".equals(principalEntry.getPrincipalClass())) {
                o2.setSelectedItem(ToolDialog.PRIN_TYPE);
            }
            else {
                Prin prin = getPrin(principalEntry.getPrincipalClass(), true);
                if (prin != null) {
                    o2.setSelectedItem(prin.CLASS);
                }
            }
        }
        o2.addItemListener(new PrincipalTypeMenuListener(o));
        this.tw.addNewComponent(o, o2, 1, 0, 1, 1, 1, 0.0, 0.0, 1, ToolWindow.LR_PADDING);
        Object o3 = b2 ? new JTextField(principalEntry.getDisplayClass(), 30) : new JTextField(30);
        o3.setPreferredSize(new Dimension(o3.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
        o3.getAccessibleContext().setAccessibleName(ToolDialog.PRIN_TYPE);
        this.tw.addNewComponent(o, o3, 2, 1, 1, 1, 1, 1.0, 0.0, 1, ToolWindow.LR_PADDING);
        JLabel o4 = new JLabel(ToolDialog.PRIN_NAME);
        Object o5 = b2 ? new JTextField(principalEntry.getDisplayName(), 40) : new JTextField(40);
        o5.setPreferredSize(new Dimension(o5.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
        o5.getAccessibleContext().setAccessibleName(ToolDialog.PRIN_NAME);
        this.tw.addNewComponent(o, o4, 3, 0, 2, 1, 1, 0.0, 0.0, 1, ToolWindow.LR_PADDING);
        this.tw.addNewComponent(o, o5, 4, 1, 2, 1, 1, 1.0, 0.0, 1, ToolWindow.LR_PADDING);
        JButton defaultButton = new JButton(PolicyTool.getMessage("OK"));
        defaultButton.addActionListener(new NewPolicyPrinOKButtonListener(this.tool, this.tw, this, o, b2));
        this.tw.addNewComponent(o, defaultButton, 5, 0, 3, 1, 1, 0.0, 0.0, 3, ToolWindow.TOP_BOTTOM_PADDING);
        JButton o6 = new JButton(PolicyTool.getMessage("Cancel"));
        CancelButtonListener o7 = new CancelButtonListener(o);
        o6.addActionListener(o7);
        this.tw.addNewComponent(o, o6, 6, 1, 3, 1, 1, 0.0, 0.0, 3, ToolWindow.TOP_BOTTOM_PADDING);
        o.getRootPane().setDefaultButton(defaultButton);
        o.getRootPane().registerKeyboardAction(o7, ToolDialog.escKey, 2);
        o.pack();
        o.setLocationRelativeTo(this.tw);
        o.setVisible(true);
    }
    
    void displayPermissionDialog(boolean b, boolean b2) {
        PolicyParser.PermissionEntry permissionEntry = null;
        TaggedList list = (TaggedList)this.getComponent(8);
        int selectedIndex = list.getSelectedIndex();
        if (b2) {
            permissionEntry = (PolicyParser.PermissionEntry)list.getObject(selectedIndex);
        }
        ToolDialog o = new ToolDialog(PolicyTool.getMessage("Permissions"), this.tool, this.tw, true);
        o.addWindowListener(new ChildWindowListener(o));
        this.getLocationOnScreen();
        o.setLayout(new GridBagLayout());
        o.setResizable(true);
        this.tw.addNewComponent(o, b2 ? new JLabel(PolicyTool.getMessage(".Edit.Permission.")) : new JLabel(PolicyTool.getMessage(".Add.New.Permission.")), 0, 0, 0, 1, 1, 0.0, 0.0, 1, ToolWindow.TOP_BOTTOM_PADDING);
        JComboBox o2 = new JComboBox();
        o2.addItem(ToolDialog.PERM);
        o2.getAccessibleContext().setAccessibleName(ToolDialog.PERM);
        for (int i = 0; i < ToolDialog.PERM_ARRAY.size(); ++i) {
            o2.addItem(((Perm)ToolDialog.PERM_ARRAY.get(i)).CLASS);
        }
        this.tw.addNewComponent(o, o2, 1, 0, 1, 1, 1, 0.0, 0.0, 1, ToolWindow.LR_BOTTOM_PADDING);
        Object o3 = b2 ? new JTextField(permissionEntry.permission, 30) : new JTextField(30);
        o3.setPreferredSize(new Dimension(o3.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
        o3.getAccessibleContext().setAccessibleName(ToolDialog.PERM);
        if (b2) {
            Perm perm = getPerm(permissionEntry.permission, true);
            if (perm != null) {
                o2.setSelectedItem(perm.CLASS);
            }
        }
        this.tw.addNewComponent(o, o3, 2, 1, 1, 1, 1, 1.0, 0.0, 1, ToolWindow.LR_BOTTOM_PADDING);
        o2.addItemListener(new PermissionMenuListener(o));
        JComboBox o4 = new JComboBox();
        o4.addItem(ToolDialog.PERM_NAME);
        o4.getAccessibleContext().setAccessibleName(ToolDialog.PERM_NAME);
        Object o5 = b2 ? new JTextField(permissionEntry.name, 40) : new JTextField(40);
        o5.setPreferredSize(new Dimension(o5.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
        o5.getAccessibleContext().setAccessibleName(ToolDialog.PERM_NAME);
        if (b2) {
            this.setPermissionNames(getPerm(permissionEntry.permission, true), o4, o5);
        }
        this.tw.addNewComponent(o, o4, 3, 0, 2, 1, 1, 0.0, 0.0, 1, ToolWindow.LR_BOTTOM_PADDING);
        this.tw.addNewComponent(o, o5, 4, 1, 2, 1, 1, 1.0, 0.0, 1, ToolWindow.LR_BOTTOM_PADDING);
        o4.addItemListener(new PermissionNameMenuListener(o));
        JComboBox o6 = new JComboBox();
        o6.addItem(ToolDialog.PERM_ACTIONS);
        o6.getAccessibleContext().setAccessibleName(ToolDialog.PERM_ACTIONS);
        Object o7 = b2 ? new JTextField(permissionEntry.action, 40) : new JTextField(40);
        o7.setPreferredSize(new Dimension(o7.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
        o7.getAccessibleContext().setAccessibleName(ToolDialog.PERM_ACTIONS);
        if (b2) {
            this.setPermissionActions(getPerm(permissionEntry.permission, true), o6, o7);
        }
        this.tw.addNewComponent(o, o6, 5, 0, 3, 1, 1, 0.0, 0.0, 1, ToolWindow.LR_BOTTOM_PADDING);
        this.tw.addNewComponent(o, o7, 6, 1, 3, 1, 1, 1.0, 0.0, 1, ToolWindow.LR_BOTTOM_PADDING);
        o6.addItemListener(new PermissionActionsMenuListener(o));
        this.tw.addNewComponent(o, new JLabel(PolicyTool.getMessage("Signed.By.")), 7, 0, 4, 1, 1, 0.0, 0.0, 1, ToolWindow.LR_BOTTOM_PADDING);
        Object o8 = b2 ? new JTextField(permissionEntry.signedBy, 40) : new JTextField(40);
        o8.setPreferredSize(new Dimension(o8.getPreferredSize().width, ToolDialog.TEXTFIELD_HEIGHT));
        o8.getAccessibleContext().setAccessibleName(PolicyTool.getMessage("Signed.By."));
        this.tw.addNewComponent(o, o8, 8, 1, 4, 1, 1, 1.0, 0.0, 1, ToolWindow.LR_BOTTOM_PADDING);
        JButton defaultButton = new JButton(PolicyTool.getMessage("OK"));
        defaultButton.addActionListener(new NewPolicyPermOKButtonListener(this.tool, this.tw, this, o, b2));
        this.tw.addNewComponent(o, defaultButton, 9, 0, 5, 1, 1, 0.0, 0.0, 3, ToolWindow.TOP_BOTTOM_PADDING);
        JButton o9 = new JButton(PolicyTool.getMessage("Cancel"));
        CancelButtonListener o10 = new CancelButtonListener(o);
        o9.addActionListener(o10);
        this.tw.addNewComponent(o, o9, 10, 1, 5, 1, 1, 0.0, 0.0, 3, ToolWindow.TOP_BOTTOM_PADDING);
        o.getRootPane().setDefaultButton(defaultButton);
        o.getRootPane().registerKeyboardAction(o10, ToolDialog.escKey, 2);
        o.pack();
        o.setLocationRelativeTo(this.tw);
        o.setVisible(true);
    }
    
    PolicyParser.PrincipalEntry getPrinFromDialog() throws Exception {
        String principalClass = new String(((JTextField)this.getComponent(2)).getText().trim());
        String s = new String(((JTextField)this.getComponent(4)).getText().trim());
        if (principalClass.equals("*")) {
            principalClass = "WILDCARD_PRINCIPAL_CLASS";
        }
        if (s.equals("*")) {
            s = "WILDCARD_PRINCIPAL_NAME";
        }
        if (principalClass.equals("WILDCARD_PRINCIPAL_CLASS") && !s.equals("WILDCARD_PRINCIPAL_NAME")) {
            throw new Exception(PolicyTool.getMessage("Cannot.Specify.Principal.with.a.Wildcard.Class.without.a.Wildcard.Name"));
        }
        if (s.equals("")) {
            throw new Exception(PolicyTool.getMessage("Cannot.Specify.Principal.without.a.Name"));
        }
        if (principalClass.equals("")) {
            principalClass = "PolicyParser.REPLACE_NAME";
            this.tool.warnings.addElement("Warning: Principal name '" + s + "' specified without a Principal class.\n\t'" + s + "' will be interpreted as a key store alias.\n\tThe final principal class will be " + "javax.security.auth.x500.X500Principal" + ".\n\tThe final principal name will be determined by the following:\n\n\tIf the key store entry identified by '" + s + "'\n\tis a key entry, then the principal name will be\n\tthe subject distinguished name from the first\n\tcertificate in the entry's certificate chain.\n\n\tIf the key store entry identified by '" + s + "'\n\tis a trusted certificate entry, then the\n\tprincipal name will be the subject distinguished\n\tname from the trusted public key certificate.");
            this.tw.displayStatusDialog(this, "'" + s + "' will be interpreted as a key store alias.  View Warning Log for details.");
        }
        return new PolicyParser.PrincipalEntry(principalClass, s);
    }
    
    PolicyParser.PermissionEntry getPermFromDialog() {
        String permission = new String(((JTextField)this.getComponent(2)).getText().trim());
        JTextField textField = (JTextField)this.getComponent(4);
        String name = null;
        if (!textField.getText().trim().equals("")) {
            name = new String(textField.getText().trim());
        }
        if (permission.equals("") || (!permission.equals("java.security.AllPermission") && name == null)) {
            throw new InvalidParameterException(PolicyTool.getMessage("Permission.and.Target.Name.must.have.a.value"));
        }
        if (permission.equals("java.io.FilePermission") && name.lastIndexOf("\\\\") > 0 && this.tw.displayYesNoDialog(this, PolicyTool.getMessage("Warning"), PolicyTool.getMessage("Warning.File.name.may.include.escaped.backslash.characters.It.is.not.necessary.to.escape.backslash.characters.the.tool.escapes"), PolicyTool.getMessage("Retain"), PolicyTool.getMessage("Edit")) != 'Y') {
            throw new NoDisplayException();
        }
        JTextField textField2 = (JTextField)this.getComponent(6);
        Object action = null;
        if (!textField2.getText().trim().equals("")) {
            action = new String(textField2.getText().trim());
        }
        JTextField textField3 = (JTextField)this.getComponent(8);
        Object signedBy = null;
        if (!textField3.getText().trim().equals("")) {
            signedBy = new String(textField3.getText().trim());
        }
        PolicyParser.PermissionEntry o = new PolicyParser.PermissionEntry(permission, name, action);
        if ((o.signedBy = signedBy) != null) {
            String[] signers = this.tool.parseSigners(o.signedBy);
            for (int i = 0; i < signers.length; ++i) {
                try {
                    if (this.tool.getPublicKeyAlias(signers[i]) == null) {
                        MessageFormat o2 = new MessageFormat(PolicyTool.getMessage("Warning.A.public.key.for.alias.signers.i.does.not.exist.Make.sure.a.KeyStore.is.properly.configured."));
                        Object[] array = { signers[i] };
                        this.tool.warnings.addElement(o2.format(array));
                        this.tw.displayStatusDialog(this, o2.format(array));
                    }
                }
                catch (Exception ex) {
                    this.tw.displayErrorDialog(this, ex);
                }
            }
            return o;
        }
        return o;
    }
    
    void displayConfirmRemovePolicyEntry() {
        int selectedIndex = ((JList)this.tw.getComponent(3)).getSelectedIndex();
        PolicyEntry[] entry = this.tool.getEntry();
        this.tw.getLocationOnScreen();
        this.setLayout(new GridBagLayout());
        this.tw.addNewComponent(this, new JLabel(PolicyTool.getMessage("Remove.this.Policy.Entry.")), 0, 0, 0, 2, 1, 0.0, 0.0, 1, ToolWindow.BOTTOM_PADDING);
        this.tw.addNewComponent(this, new JLabel(entry[selectedIndex].codebaseToString()), 1, 0, 1, 2, 1, 0.0, 0.0, 1);
        this.tw.addNewComponent(this, new JLabel(entry[selectedIndex].principalsToString().trim()), 2, 0, 2, 2, 1, 0.0, 0.0, 1);
        Vector<Object> permissionEntries = entry[selectedIndex].getGrantEntry().permissionEntries;
        for (int i = 0; i < permissionEntries.size(); ++i) {
            JLabel o = new JLabel("    " + PermissionEntryToUserFriendlyString((PolicyParser.PermissionEntry)permissionEntries.elementAt(i)));
            if (i == permissionEntries.size() - 1) {
                this.tw.addNewComponent(this, o, 3 + i, 1, 3 + i, 1, 1, 0.0, 0.0, 1, ToolWindow.BOTTOM_PADDING);
            }
            else {
                this.tw.addNewComponent(this, o, 3 + i, 1, 3 + i, 1, 1, 0.0, 0.0, 1);
            }
        }
        JPanel o2 = new JPanel();
        o2.setLayout(new GridBagLayout());
        JButton defaultButton = new JButton(PolicyTool.getMessage("OK"));
        defaultButton.addActionListener(new ConfirmRemovePolicyEntryOKButtonListener(this.tool, this.tw, this));
        this.tw.addNewComponent(o2, defaultButton, 0, 0, 0, 1, 1, 0.0, 0.0, 3, ToolWindow.LR_PADDING);
        JButton o3 = new JButton(PolicyTool.getMessage("Cancel"));
        CancelButtonListener o4 = new CancelButtonListener(this);
        o3.addActionListener(o4);
        this.tw.addNewComponent(o2, o3, 1, 1, 0, 1, 1, 0.0, 0.0, 3, ToolWindow.LR_PADDING);
        this.tw.addNewComponent(this, o2, 3 + permissionEntries.size(), 0, 3 + permissionEntries.size(), 2, 1, 0.0, 0.0, 3, ToolWindow.TOP_BOTTOM_PADDING);
        this.getRootPane().setDefaultButton(defaultButton);
        this.getRootPane().registerKeyboardAction(o4, ToolDialog.escKey, 2);
        this.pack();
        this.setLocationRelativeTo(this.tw);
        this.setVisible(true);
    }
    
    void displaySaveAsDialog(int n) {
        FileDialog fileDialog = new FileDialog(this.tw, PolicyTool.getMessage("Save.As"), 1);
        fileDialog.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent windowEvent) {
                windowEvent.getWindow().setVisible(false);
            }
        });
        fileDialog.setVisible(true);
        if (fileDialog.getFile() == null || fileDialog.getFile().equals("")) {
            return;
        }
        String path = new File(fileDialog.getDirectory(), fileDialog.getFile()).getPath();
        fileDialog.dispose();
        try {
            this.tool.savePolicy(path);
            this.tw.displayStatusDialog(null, new MessageFormat(PolicyTool.getMessage("Policy.successfully.written.to.filename")).format(new Object[] { path }));
            ((JTextField)this.tw.getComponent(1)).setText(path);
            this.tw.setVisible(true);
            this.userSaveContinue(this.tool, this.tw, this, n);
        }
        catch (FileNotFoundException ex) {
            if (path == null || path.equals("")) {
                this.tw.displayErrorDialog(null, new FileNotFoundException(PolicyTool.getMessage("null.filename")));
            }
            else {
                this.tw.displayErrorDialog(null, ex);
            }
        }
        catch (Exception ex2) {
            this.tw.displayErrorDialog(null, ex2);
        }
        return;
    }
    
    void displayUserSave(int n) {
        if (this.tool.modified) {
            this.tw.getLocationOnScreen();
            this.setLayout(new GridBagLayout());
            this.tw.addNewComponent(this, new JLabel(PolicyTool.getMessage("Save.changes.")), 0, 0, 0, 3, 1, 0.0, 0.0, 1, ToolWindow.L_TOP_BOTTOM_PADDING);
            JPanel panel = new JPanel();
            panel.setLayout(new GridBagLayout());
            JButton button = new JButton();
            ToolWindow.configureButton(button, "Yes");
            button.addActionListener(new UserSaveYesButtonListener(this, this.tool, this.tw, n));
            this.tw.addNewComponent(panel, button, 0, 0, 0, 1, 1, 0.0, 0.0, 3, ToolWindow.LR_BOTTOM_PADDING);
            JButton button2 = new JButton();
            ToolWindow.configureButton(button2, "No");
            button2.addActionListener(new UserSaveNoButtonListener(this, this.tool, this.tw, n));
            this.tw.addNewComponent(panel, button2, 1, 1, 0, 1, 1, 0.0, 0.0, 3, ToolWindow.LR_BOTTOM_PADDING);
            JButton button3 = new JButton();
            ToolWindow.configureButton(button3, "Cancel");
            CancelButtonListener cancelButtonListener = new CancelButtonListener(this);
            button3.addActionListener(cancelButtonListener);
            this.tw.addNewComponent(panel, button3, 2, 2, 0, 1, 1, 0.0, 0.0, 3, ToolWindow.LR_BOTTOM_PADDING);
            this.tw.addNewComponent(this, panel, 1, 0, 1, 1, 1, 0.0, 0.0, 1);
            this.getRootPane().registerKeyboardAction(cancelButtonListener, ToolDialog.escKey, 2);
            this.pack();
            this.setLocationRelativeTo(this.tw);
            this.setVisible(true);
        }
        else {
            this.userSaveContinue(this.tool, this.tw, this, n);
        }
    }
    
    void userSaveContinue(PolicyTool policyTool, ToolWindow parent, ToolDialog toolDialog, int n) {
        switch (n) {
            case 1: {
                parent.setVisible(false);
                parent.dispose();
                System.exit(0);
            }
            case 2: {
                try {
                    policyTool.openPolicy(null);
                }
                catch (Exception ex) {
                    policyTool.modified = false;
                    parent.displayErrorDialog(null, ex);
                }
                JList o = new JList(new DefaultListModel());
                o.setVisibleRowCount(15);
                o.setSelectionMode(0);
                o.addMouseListener(new PolicyListListener(policyTool, parent));
                parent.replacePolicyList(o);
                ((JTextField)parent.getComponent(1)).setText("");
                parent.setVisible(true);
                break;
            }
            case 3: {
                FileDialog fileDialog = new FileDialog(parent, PolicyTool.getMessage("Open"), 0);
                fileDialog.addWindowListener(new WindowAdapter(this) {
                    @Override
                    public void windowClosing(WindowEvent windowEvent) {
                        windowEvent.getWindow().setVisible(false);
                    }
                });
                fileDialog.setVisible(true);
                if (fileDialog.getFile() == null || fileDialog.getFile().equals("")) {
                    return;
                }
                String path = new File(fileDialog.getDirectory(), fileDialog.getFile()).getPath();
                try {
                    policyTool.openPolicy(path);
                    DefaultListModel<String> dataModel = new DefaultListModel();
                    JList<Object> list = new JList(dataModel);
                    list.setVisibleRowCount(15);
                    list.setSelectionMode(0);
                    list.addMouseListener(new PolicyListListener(policyTool, parent));
                    PolicyEntry[] entry = policyTool.getEntry();
                    if (entry != null) {
                        for (int i = 0; i < entry.length; ++i) {
                            dataModel.addElement(entry[i].headerToString());
                        }
                    }
                    parent.replacePolicyList(list);
                    policyTool.modified = false;
                    ((JTextField)parent.getComponent(1)).setText(path);
                    parent.setVisible(true);
                    if (policyTool.newWarning) {
                        parent.displayStatusDialog(null, PolicyTool.getMessage("Errors.have.occurred.while.opening.the.policy.configuration.View.the.Warning.Log.for.more.information."));
                    }
                    break;
                }
                catch (Exception ex2) {
                    JList<Object> list2 = new JList(new DefaultListModel());
                    list2.setVisibleRowCount(15);
                    list2.setSelectionMode(0);
                    list2.addMouseListener(new PolicyListListener(policyTool, parent));
                    parent.replacePolicyList(list2);
                    policyTool.setPolicyFileName(null);
                    policyTool.modified = false;
                    ((JTextField)parent.getComponent(1)).setText("");
                    parent.setVisible(true);
                    parent.displayErrorDialog(null, new MessageFormat(PolicyTool.getMessage("Could.not.open.policy.file.policyFile.e.toString.")).format(new Object[] { path, ex2.toString() }));
                }
                break;
            }
        }
    }
    
    void setPermissionNames(Perm perm, JComboBox comboBox, JTextField textField) {
        comboBox.removeAllItems();
        comboBox.addItem(ToolDialog.PERM_NAME);
        if (perm == null) {
            textField.setEditable(true);
        }
        else if (perm.TARGETS == null) {
            textField.setEditable(false);
        }
        else {
            textField.setEditable(true);
            for (int i = 0; i < perm.TARGETS.length; ++i) {
                comboBox.addItem(perm.TARGETS[i]);
            }
        }
    }
    
    void setPermissionActions(Perm perm, JComboBox comboBox, JTextField textField) {
        comboBox.removeAllItems();
        comboBox.addItem(ToolDialog.PERM_ACTIONS);
        if (perm == null) {
            textField.setEditable(true);
        }
        else if (perm.ACTIONS == null) {
            textField.setEditable(false);
        }
        else {
            textField.setEditable(true);
            for (int i = 0; i < perm.ACTIONS.length; ++i) {
                comboBox.addItem(perm.ACTIONS[i]);
            }
        }
    }
    
    static String PermissionEntryToUserFriendlyString(PolicyParser.PermissionEntry permissionEntry) {
        String str = permissionEntry.permission;
        if (permissionEntry.name != null) {
            str = str + " " + permissionEntry.name;
        }
        if (permissionEntry.action != null) {
            str = str + ", \"" + permissionEntry.action + "\"";
        }
        if (permissionEntry.signedBy != null) {
            str = str + ", signedBy " + permissionEntry.signedBy;
            return str;
        }
        return str;
    }
    
    static String PrincipalEntryToUserFriendlyString(PolicyParser.PrincipalEntry principalEntry) {
        StringWriter out = new StringWriter();
        principalEntry.write(new PrintWriter(out));
        return out.toString();
    }
    
    static {
        escKey = KeyStroke.getKeyStroke(27, 0);
        PERM = PolicyTool.getMessage("Permission.");
        PRIN_TYPE = PolicyTool.getMessage("Principal.Type.");
        PRIN_NAME = PolicyTool.getMessage("Principal.Name.");
        PERM_NAME = PolicyTool.getMessage("Target.Name.");
        PERM_ACTIONS = PolicyTool.getMessage("Actions.");
        TEXTFIELD_HEIGHT = new JComboBox().getPreferredSize().height;
        (ToolDialog.PERM_ARRAY = new ArrayList()).add(new AllPerm());
        ToolDialog.PERM_ARRAY.add(new AudioPerm());
        ToolDialog.PERM_ARRAY.add(new AuthPerm());
        ToolDialog.PERM_ARRAY.add(new AWTPerm());
        ToolDialog.PERM_ARRAY.add(new DelegationPerm());
        ToolDialog.PERM_ARRAY.add(new FilePerm());
        ToolDialog.PERM_ARRAY.add(new URLPerm());
        ToolDialog.PERM_ARRAY.add(new InqSecContextPerm());
        ToolDialog.PERM_ARRAY.add(new LogPerm());
        ToolDialog.PERM_ARRAY.add(new MgmtPerm());
        ToolDialog.PERM_ARRAY.add(new MBeanPerm());
        ToolDialog.PERM_ARRAY.add(new MBeanSvrPerm());
        ToolDialog.PERM_ARRAY.add(new MBeanTrustPerm());
        ToolDialog.PERM_ARRAY.add(new NetPerm());
        ToolDialog.PERM_ARRAY.add(new PrivCredPerm());
        ToolDialog.PERM_ARRAY.add(new PropPerm());
        ToolDialog.PERM_ARRAY.add(new ReflectPerm());
        ToolDialog.PERM_ARRAY.add(new RuntimePerm());
        ToolDialog.PERM_ARRAY.add(new SecurityPerm());
        ToolDialog.PERM_ARRAY.add(new SerialPerm());
        ToolDialog.PERM_ARRAY.add(new ServicePerm());
        ToolDialog.PERM_ARRAY.add(new SocketPerm());
        ToolDialog.PERM_ARRAY.add(new SQLPerm());
        ToolDialog.PERM_ARRAY.add(new SSLPerm());
        ToolDialog.PERM_ARRAY.add(new SubjDelegPerm());
        (ToolDialog.PRIN_ARRAY = new ArrayList()).add(new KrbPrin());
        ToolDialog.PRIN_ARRAY.add(new X500Prin());
    }
}
